#include <iostream>
#include <string>
#include <stdlib.h>
#include <assert.h>
#include "listas_ligadas_dinamicas.h"
using namespace std;

void inicializaListaLigada(LISTA* l) {
	l->primeiro = NULL;
}

void exibeLista(LISTA* l) {
    for (NO* no = l->primeiro; no != NULL; no = no->prox) {
		cout << no->elem << " ";
	}

	cout << endl;
}

NO* criaNo() {
	NO* no = (NO*) malloc (sizeof(NO));
	no->prox = NULL;
	return no;
}

void insereNoInicio(LISTA *l, int elem) {
	NO* no = criaNo();
	no->elem = elem;
	no->prox = l->primeiro;
	l->primeiro = no;
}

void insereNoFim(LISTA* l, int elem) {
	if(vazio(l)) {
		insereNoInicio(l, elem);
		return;
	}

	NO* no = criaNo();
	no->elem = elem;
	NO* p = l->primeiro;	
 
	while(p->prox != NULL){
		p = p->prox;
	}

	p->prox = no;
}

bool vazio(LISTA* l) {
	return l->primeiro == NULL;
}

int removePrimeiro(LISTA* l) {
	assert(!vazio(l));
	NO* aux = l->primeiro;
	int elem = aux->elem;
	l->primeiro = l->primeiro->prox;
	free(aux);
	return elem;
}

int removeUltimo(LISTA *l) {
	assert(!vazio(l));
	NO* ant = NULL;
	NO* aux = l->primeiro;

	while(aux->prox != NULL){
		ant = aux;
		aux = aux->prox;
	}

	if(ant == NULL){
		return removePrimeiro(l);
	}

	ant-> prox = NULL;
	int valor = aux->elem;
	free(aux);
	return valor;
}

bool remove(LISTA *l, int elem) {
	NO* ant = NULL;
	NO* no = l->primeiro;

	while(no != NULL) {
		if(elem == no->elem){
			if(ant == NULL){
				removePrimeiro(l);
			} else {
				ant->prox = no->prox;
				free(no);
			}

			return true;
		}
		
		ant = no;
		no = no->prox;
	}

	return false;
}

int main() {
	LISTA l;
	inicializaListaLigada(&l);

	while(true) {
		int elem;
		char cmd;
		cin >> cmd;

		if(cmd != 'p' && cmd != 'u') {
			cin >> elem;
		}
		
		if(cmd == 'i') {
			cout << "insere " << elem << endl;
			insereNoInicio(&l, elem);
		} else if(cmd == 'e') {
			cout << "exclui " << elem << endl;
			remove(&l, elem);
		} else if(cmd == 'h') {
			cout << "insere no fim " << elem << endl;
			insereNoFim(&l, elem);
		} else if(cmd == 'p') {
			cout << "remove primeiro " << endl;
			removePrimeiro(&l);
		} else if(cmd == 'u') {
			cout << "remove ultimo " << endl;
			removeUltimo(&l);
		} else {
			cout << "comando invalido" << endl;
		}

		cout << "exibe lista: " << ends;
		exibeLista(&l);
	}

	return 0;
}